VERSION 5.00
Object = "{33101C00-75C3-11CF-A8A0-444553540000}#1.0#0"; "CSWSK32.OCX"
Begin VB.Form MainForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "VB Talker Server"
   ClientHeight    =   1335
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4830
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   1335
   ScaleWidth      =   4830
   StartUpPosition =   2  'CenterScreen
   Begin SocketWrenchCtrl.Socket Socket1 
      Index           =   0
      Left            =   2760
      Top             =   600
      _Version        =   65536
      _ExtentX        =   741
      _ExtentY        =   741
      _StockProps     =   0
      AutoResolve     =   -1  'True
      Backlog         =   5
      Binary          =   -1  'True
      Blocking        =   -1  'True
      Broadcast       =   0   'False
      BufferSize      =   0
      HostAddress     =   ""
      HostFile        =   ""
      HostName        =   ""
      InLine          =   0   'False
      Interval        =   0
      KeepAlive       =   0   'False
      Library         =   ""
      Linger          =   0
      LocalPort       =   0
      LocalService    =   ""
      Protocol        =   0
      RemotePort      =   0
      RemoteService   =   ""
      ReuseAddress    =   0   'False
      Route           =   -1  'True
      Timeout         =   0
      Type            =   1
      Urgent          =   0   'False
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Kick"
      Height          =   375
      Left            =   3480
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
   Begin VB.ListBox List1 
      Height          =   1095
      IntegralHeight  =   0   'False
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3255
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Function GetSetting(Key As String)
  Dim ret As Long
  Dim Temp As String * 50
  FileName = App.Path & "\TALKER.INI"
  ret = GetPrivateProfileString("TALKER", Key, "", Temp, Len(Temp), FileName)
  If ret = 0 Then
    MsgBox "There was an error reading TALKER.INI.", vbCritical, "Error"
    End
  Else
    GetSetting = Temp
  End If
End Function

Private Sub Command1_Click()
  Dim I As Integer
  If List1.Text <> "" Then
    For I = 1 To Socket1.Count - 1
      If UserData(I).UserName = List1.Text Then
        Broadcast "** " & List1.Text & " has been kicked out of chat **" + vbCrLf, I
        SendData "** You have been kicked out of chat **", I
        Socket1(I).Disconnect
        Cleanup (I)
        Exit For
      End If
    Next
  End If
End Sub

Private Sub Form_Load()
  MaxUsers = GetSetting("MAXUSERS")
  ReDim UserData(MaxUsers) As UserRec
  Socket1(0).LocalPort = GetSetting("PORT")
  Socket1(0).AddressFamily = AF_INET
  Socket1(0).Protocol = IPPROTO_IP
  Socket1(0).SocketType = SOCK_STREAM
  Socket1(0).Blocking = False
  Socket1(0).AutoResolve = False
  Socket1(0).Listen
End Sub

Private Function NewSocket(SocketId As Integer) As Integer
  Dim nIndex As Integer
  If (Socket1.Count - 1) = MaxUsers Then
    Socket1(0).Accept = SocketId
    SendData "All lines are full. Try back later.", 0
    Socket1(0).Disconnect
    Socket1(0).Listen
    NewSocket = 0
    Exit Function
  End If
  For nIndex = 1 To LastSocket
    If Not Socket1(nIndex).Connected Then
      UserData(nIndex).MsgQueue = ""
      UserData(nIndex).UserName = ""
      UserData(nIndex).Status = ""
      UserData(nIndex).Buffer = ""
      Exit For
    End If
  Next nIndex
  If nIndex > LastSocket Then
    LastSocket = LastSocket + 1: nIndex = LastSocket
    Load Socket1(nIndex)
  End If
  Socket1(nIndex).AddressFamily = AF_INET
  Socket1(nIndex).Protocol = IPPROTO_IP
  Socket1(nIndex).SocketType = SOCK_STREAM
  Socket1(nIndex).LocalPort = IPPORT_ANY
  Socket1(nIndex).Binary = True
  Socket1(nIndex).BufferSize = 1024
  Socket1(nIndex).Blocking = False
  Socket1(nIndex).AutoResolve = False
  NewSocket = nIndex
End Function

Private Sub SendData(Text As String, Index As Integer)
  Socket1(Index).Write Text, Len(Text)
End Sub

Private Sub SendFile(File As String, Index As Integer)
  Dim Temp As String
  On Error GoTo errHandler
    Open App.Path & "\TEXT\" & File For Input As #1
    Do While Not EOF(1)
      Line Input #1, Temp
      SendData Temp + vbCrLf, Index
    Loop
    Close #1
  Exit Sub
errHandler:
  SendData "** FILE: " & File & " does not exist. **" & vbCrLf, Index
End Sub

Private Sub Broadcast(Msg As String, Index As Integer)
  Dim I As Integer
  For I = 1 To Socket1.Count - 1
    If I <> Index Then
      If Socket1(I).Connected = True Then
        If UserData(I).UserName <> "" Then
          UserData(I).MsgQueue = UserData(I).MsgQueue + Msg
          If UserData(I).Buffer = "" Then
            SendData Chr(8) + Chr(8) + Chr(8) + "   " + Chr(8) + Chr(8) + Chr(8), I
            SendData UserData(I).MsgQueue, I
            SendData "> ", I
            UserData(I).MsgQueue = ""
          End If
        End If
      End If
    End If
  Next
End Sub

Private Sub Cleanup(Index As Integer)
  UserData(Index).UserName = ""
  UserData(Index).MsgQueue = ""
  UserData(Index).Status = ""
  UserData(Index).Buffer = ""
  List1.Clear
  For I = 1 To Socket1.Count - 1
    If UserData(I).UserName <> "" Then
      List1.AddItem UserData(I).UserName
    End If
  Next
End Sub

Private Sub ParseCommand(Index As Integer, Buffer As String)
  Dim I As Integer
  Select Case UserData(Index).Status
    Case "LOGIN":
      Taken = 0
      Buffer = UCase(Trim(Buffer))
      If Buffer = "" Then
        SendData "Nickname: ", Index
        Exit Sub
      End If
      For I = 1 To Socket1.Count - 1
        If UserData(I).UserName = Buffer Then
          Taken = 1
        End If
      Next
      If Taken = 1 Then
        SendData vbCrLf + "Someone is already using that name. Please try another." + vbCrLf + vbCrLf, Index
        SendData "Nickname: ", Index
      Else
        UserData(Index).UserName = Buffer
        UserData(Index).Status = "CHATTING"
        SendData vbCrLf + "You are now in chat." + vbCrLf, Index
        SendData vbCrLf + "> ", Index
        Broadcast "** " & UserData(Index).UserName & " has joined chat **" & vbCrLf, Index
        List1.AddItem Buffer
      End If
    Case "CHATTING":
      If UserData(Index).MsgQueue <> "" Then
        SendData UserData(Index).MsgQueue, Index
        UserData(Index).MsgQueue = ""
      End If
      If Buffer = "/?" Then
        SendFile "HELP.TXT", Index
      ElseIf UCase(Buffer) = "/Q" Then
        Broadcast "** " & UserData(Index).UserName & " has left chat **" & vbCrLf, Index
        Socket1(Index).Disconnect
        Cleanup (Index)
      ElseIf Buffer <> "" Then
        Broadcast UserData(Index).UserName + ": " + Buffer + vbCrLf, Index
      End If
      SendData "> ", Index
  End Select
End Sub

Private Sub Socket1_Accept(Index As Integer, SocketId As Integer)
  nSocket = NewSocket(SocketId)
  If nSocket <> 0 Then
    Socket1(nSocket).Accept = SocketId
  End If
End Sub

Private Sub Socket1_Connect(Index As Integer)
  UserData(Index).Status = "LOGIN"
  SendData "Connection established." + vbCrLf + vbCrLf, Index
  SendFile "CONNECT.TXT", Index
  SendData "Nickname: ", Index
End Sub

Private Sub Socket1_Disconnect(Index As Integer)
  Broadcast "** " & UserData(Index).UserName & " has left chat **" & vbCrLf, Index
  Cleanup (Index)
End Sub

Private Sub Socket1_Read(Index As Integer, DataLength As Integer, IsUrgent As Integer)
  Dim strBuffer As String
  Dim oldBuffer As String
  Dim cchBuffer As Integer
  cchBuffer = Socket1(Index).Read(strBuffer, 1024)
  If cchBuffer < 1 Then Exit Sub
  If (strBuffer = vbCrLf) Or (strBuffer = Chr(13)) Or (strBuffer = Chr(10)) Then
    SendData strBuffer, Index
    oldBuffer = UserData(Index).Buffer
    UserData(Index).Buffer = ""
    ParseCommand Index, oldBuffer
  ElseIf Asc(strBuffer) = 8 Then
    If Len(UserData(Index).Buffer) <> 0 Then
      SendData strBuffer, Index
      SendData " ", Index
      SendData Chr(8), Index
      UserData(Index).Buffer = Mid(UserData(Index).Buffer, 1, Len(UserData(Index).Buffer) - 1)
    End If
  Else
    SendData strBuffer, Index
    UserData(Index).Buffer = UserData(Index).Buffer + strBuffer
  End If
End Sub

